



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>js实现欧几里得算法</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">js实现欧几里得算法</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-26 23:10:42 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>概念<br />
在数学中，辗转相除法，又称欧几里得算法（英语：Euclidean algorithm），是求最大公约数的算法。</p>
<p>证明<br />
首先假设有两个数a和b,其中a是不小于b的数，记a被b除的余数为r,那么a可以写成这样的形式：<br />
a = b*q + r<br />
假设a和b的一个约数为u，那么a和b都能被u整除,即：</p>
<p>a = su<br />
b = tu<br />
带入原式可得</p>
<p>su = (tu)<em>q + r<br />
r = su - (tu)</em>q<br />
r = u*(s-tq)<br />
所以 u 也是r 的公约数,即</p>
<p>a和b的约数也整除它们的余数r，所以a和b的任一约数同时也是b和r的约数。</p>
<p>同理可证明b和r的任一公约数也是a的公约数。<br />
假设b和r的任一公约数为 v,则有：</p>
<p>b = mv<br />
r = nv<br />
带入原式可得</p>
<p>a = (mv)<em>q + nv<br />
a = v</em>(mq+n)<br />
所以a和b的约数组成的集合与b和r的约数集合是相等的，那么a和b的最大约数和b和r的最大约数也相等。</p>
<p>实现<br />
用js实现代码如下：</p>
<p>function gcd(a,b){<br />
let max = a&gt;b?a:b;<br />
let min = a&gt;b?b:a;<br />
let r = max%min;<br />
if(r==0){<br />
return min;<br />
}else{<br />
return gcd(min,r)<br />
}<br />
}<br />
简化版本如下：</p>
<p>function gcd(a,b){<br />
return b===0?a:gcd(b,a%b);<br />
}<br />
参考<br />
辗转相除法[维基百科]<br />
欧几里得算法求最大公约数的数学原理<br />
js实现欧几里得算法/辗转相除法</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qnj4vk8.html">mysql介绍及安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/495g5d0q.html">iOS--使用UIImageView进行GIF动图播放</a>
		</li>
						<li><a href="https://www.batexi.com/a/4953r0e8.html">从零开始学 Java - CentOS 安装 JDK</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93jgzz8.html">Bootstrap  Fileupload  文件上传</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2mel38.html">WEB进度条控件</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j2k2g8.html">AMap公交线路查询</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8ow2ox9.html">POJ 1273 网络流&lpar;最大流&rpar;模板</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8elrgjq.html">软件项目第一个Sprint评论</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj6d549.html">tomcat部署web项目的方式 转</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz71lg8.html">Java面试题&mdash;初级（8）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me1l1oq.html">java爬虫实现爬取百度风云榜Top10</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj1l4l8.html">死磕NodeJs之REPL与For Server&comma;我的艰辛的旅程&lpar;一&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/960drp39.html">Java继承和组合</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwryy09.html">AJAX从入门到放弃（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2nemx9.html">UOJ224 NOI2016 旷野大计算 构造、造计算机</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rngv48.html">MVC4 下DropDownList使用方法（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj6r669.html">python测试开发django-48&period;xadmin上传图片django-stdimage</a>
		</li>
						<li><a href="https://www.batexi.com/a/9637dgv9.html">nginx服务器的rewrite功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwl0l7k9.html">learning docker steps&lpar;8&rpar;  ----- docker network 初次体验</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvrejdq.html">操作系统-百科：Kylin （中国自主知识产权操作系统）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qdjdgv0q.html">HTML5 表单元素和属性</a>
			</li>
						<li><a href="https://www.batexi.com/a/8konro3q.html">QtQuickcontrols2控件使用参考</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwl54pr9.html">20145328《网络对抗技术》Final</a>
			</li>
						<li><a href="https://www.batexi.com/a/qx2o4nd8.html">stm32时钟树讲解</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o4v2v5q.html">USACO 1&period;3 Ski Course Design - 暴力</a>
			</li>
						<li><a href="https://www.batexi.com/a/8em522x9.html">Android和PHP开发最佳实践</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gp40e79.html">奖券数目&vert;2015年蓝桥杯B组题解析第一题-fishers</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2kmn2oq.html">Bi-shoe and Phi-shoe（欧拉函数&sol;素筛）题解</a>
			</li>
						<li><a href="https://www.batexi.com/a/953mldz8.html">论文笔记&mdash;&mdash;Deep Residual Learning for Image Recognition</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ppk5lz9.html">HDU 1548 A strange lift （Dijkstra）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
